
Ruby - Bug #13222

Array#sum inconsistency when init value is non-numeric

02/17/2017 10:59 AM - matsuda (Akira Matsuda)

Status: Closed   

Priority: Normal   

Assignee:    

Target version:    

ruby -v: ruby 2.5.0dev (2017-02-17 trunk 57644)

[x86_64-darwin15]

Backport: 2.2: DONTNEED, 2.3: DONTNEED, 2.4:

DONE

Description

Since Array#sum skips calling plus for 0 https://github.com/ruby/ruby/blob/c85a58d/array.c#L5831-L5832, it doesn't raise when the

receiver array consists of 0 only, even when the "init" value is non-numeric.

% ruby -e "p [1].sum('a')"

-e:1:in `sum': String can't be coerced into Integer (TypeError)

 
% ruby -e "p [0].sum('a')"

"a"

 
% ruby -e "p [0, 0, 0].sum('a')"

"a"

Associated revisions

Revision 3203ae53ffeea05c7719d4ba863e0ca492b305cd - 02/18/2017 04:23 AM - nobu (Nobuyoshi Nakada)

array.c: check if numeric

array.c (finish_exact_sum): add 0 and the initial value to check

if the latter is numeric.  [ruby-core:79572] [Bug #13222]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@57651 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 3203ae53 - 02/18/2017 04:23 AM - nobu (Nobuyoshi Nakada)

array.c: check if numeric

array.c (finish_exact_sum): add 0 and the initial value to check

if the latter is numeric.  [ruby-core:79572] [Bug #13222]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@57651 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision d77b1756fdfdc1ec6ab7ba26754da27d1492d169 - 12/20/2017 02:53 PM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 57649,57651: [Backport #13222]

    array.c: finish_exact_sum

    * array.c (finish_exact_sum): extract duplicate code from

      rb_ary_sum.

    array.c: check if numeric

    * array.c (finish_exact_sum): add 0 and the initial value to check

      if the latter is numeric.  [ruby-core:79572] [Bug #13222]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_4@61361 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision d77b1756 - 12/20/2017 02:53 PM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 57649,57651: [Backport #13222]

    array.c: finish_exact_sum

    * array.c (finish_exact_sum): extract duplicate code from

      rb_ary_sum.
https://github.com/ruby/ruby/blob/c85a58d/array.c#L5831-L5832


    array.c: check if numeric

    * array.c (finish_exact_sum): add 0 and the initial value to check

      if the latter is numeric.  [ruby-core:79572] [Bug #13222]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_4@61361 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 02/18/2017 04:23 AM - nobu (Nobuyoshi Nakada)

- Status changed from Open to Closed

Applied in changeset r57651.

array.c: check if numeric

array.c (finish_exact_sum): add 0 and the initial value to check

if the latter is numeric.  [ruby-core:79572] [Bug #13222]

#2 - 03/23/2017 02:00 AM - mtsmfm (Fumiaki Matsushima)

I confirmed this behavior appears not only 2.5.0dev but also 2.4.x.

$ docker run ruby:2.4.1 ruby -e "p [0].sum('a')"

"a"

 
$ docker run ruby:2.4.0 ruby -e "p [0].sum('a')"

"a"

 Should we backport the patch?

#3 - 03/23/2017 03:46 AM - usa (Usaku NAKAMURA)

- Backport changed from 2.2: UNKNOWN, 2.3: UNKNOWN, 2.4: UNKNOWN to 2.2: DONTNEED, 2.3: DONTNEED, 2.4: REQUIRED

#4 - 12/20/2017 02:54 PM - nagachika (Tomoyuki Chikanaga)

- Backport changed from 2.2: DONTNEED, 2.3: DONTNEED, 2.4: REQUIRED to 2.2: DONTNEED, 2.3: DONTNEED, 2.4: DONE

ruby_2_4 r61361 merged revision(s) 57649,57651.
